﻿<%@ WebHandler Language="C#" Class="ServerManager.HMain"%>

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.SessionState;
using Newtonsoft.Json;

namespace ServerManager
{
    public class AjaxResult
    {
        public bool success;
        public string error;

    }
    public class HMain : IHttpHandler, IRequiresSessionState
    {
        public void ProcessRequest(HttpContext context)
        {
            string action = context.Request["ac"];
            if (context.Request.Form.Count == 0 && (action != "getVersion" || action != "getVersionHistory")) context.Response.End();

            object res = "NO RESPONSE";

            switch (action)
            {
                case "get":
                    res = UtilsConvert.ConvertJsonNS(GetProjects());
                    context.Response.ContentType = "text/plain";
                    break;
                case "download":
                    res = UtilsConvert.ConvertJsonNS(DownLoad(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "update":
                    res = UtilsConvert.ConvertJsonNS(Update(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "getversionsforcategory":
                    res = UtilsConvert.ConvertJsonNS(GetVersionsForCategory(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "getversionsforappsite":
                    res = UtilsConvert.ConvertJsonNS(GetVersionsForAppSite(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "create":
                    res = UtilsConvert.ConvertJsonNS(Create(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "delete":
                    Delete(context);
                    context.Response.ContentType = "text/plain";
                    break;
                case "savesslparams":
                    res = UtilsConvert.ConvertJsonNS(SaveSSLParameters(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "getserverinfo":
                    res = UtilsConvert.ConvertJsonNS(GetServerInfo(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "savecertstring":
                    res = UtilsConvert.ConvertJsonNS(SaveCertString(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "saverootstring":
                    res = UtilsConvert.ConvertJsonNS(AddRootCertString(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "removecertstring":
                    res = UtilsConvert.ConvertJsonNS(RemoveCertString(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "removerootcert":
                    res = UtilsConvert.ConvertJsonNS(RemoveRootCert(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "statecertstring":
                    res = UtilsConvert.ConvertJsonNS(StateCertString(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "changecertuser":
                    res = UtilsConvert.ConvertJsonNS(ChangeCertUser(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "startservice":
                    res = UtilsConvert.ConvertJsonNS(StartStopService(context, true));
                    context.Response.ContentType = "text/plain";
                    break;
                case "stopservice":
                    res = UtilsConvert.ConvertJsonNS(StartStopService(context, false));
                    context.Response.ContentType = "text/plain";
                    break;
                case "refreshc":
                    res = UtilsConvert.ConvertJsonNS(RefreshCategory(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "deletefolder":
                    res = UtilsConvert.ConvertJsonNS(DeleteFolder(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "deletesvc":
                    res = UtilsConvert.ConvertJsonNS(DeleteServices(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "savefiles":
                    res = UtilsConvert.ConvertJsonNS(SaveFiles(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "commitcert":
                    res = UtilsConvert.ConvertJsonNS(CommitCerts(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "beginupdate":
                    res = UtilsConvert.ConvertJsonNS(BeginUpdateProcess());
                    context.Response.ContentType = "text/plain";
                    break;
                case "getVersion":
                    res = UtilsConvert.ConvertJsonNS(GetProductVersion(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "getVersionHistory":
                    res = UtilsConvert.ConvertJsonNS(GetVersionHistory(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "getlogs":
                    res = UtilsConvert.ConvertJsonNS(GetProductLogs(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "deleteTempInit":
                    res = UtilsConvert.ConvertJsonNS(DeleteTempInit(context));
                    context.Response.ContentType = "text/plain";
                    break;
                case "deleteTempGetData":
                    res = UtilsConvert.ConvertJsonNS(DeleteTempGetData(context));
                    context.Response.ContentType = "text/plain";
                    break;
            }

            context.Response.Write(res);
            context.Response.End();
        }
        private object DeleteTempGetData(HttpContext context)
        {
            try
            {
                var json = context.Request["apps"];
                List<AppSite> apps = JsonConvert.DeserializeObject(json, typeof(List<AppSite>)) as List<AppSite>;
                return AppSitesInfo.GetDataForTempDel(apps);
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        private object DeleteTempInit(HttpContext context)
        {
            try
            {
                var json = context.Request["apps"];
                if (Utils.IsStringEmpty(json)) return new AjaxResult { success = true, error = "Пришедший с клиента параметр пуст" };
                List<AppSite> apps = JsonConvert.DeserializeObject(json, typeof(List<AppSite>)) as List<AppSite>;
                json = context.Request["shed"];
                Shedules shedule = null;
                if (json != null)
                {
                    shedule = JsonConvert.DeserializeObject(json, typeof(Shedules)) as Shedules;
                    if (shedule != null)
                        shedule.BeginDateTime = Utils.DateTimeByValue(shedule.StringDateTime);
                }

                var msg = AppSitesInfo.InitTempDel(apps, shedule != null, shedule);
                return new AjaxResult { success = true, error = msg };

            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        private object GetProductLogs(HttpContext context)
        {
            try
            {
                var json = context.Request["app"];
                var app = JsonConvert.DeserializeObject(json, typeof(AppSite)) as AppSite;
                if (app == null) return null;
                return app.GetLogs();
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        private static object GetVersionHistory(HttpContext context)
        {
            try
            {
                var appID = context.Request.Params["appID"];
                var ver = context.Request.Params["ver"];
                return AppSite.GetAppVersionHistory(null, appID, ver);
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        public bool IsReusable { get { return false; } }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Удаление каталога
        /// </summary>
        /// <returns></returns>
        private static object DeleteFolder(HttpContext context)
        {
            try
            {
                var path = context.Request.Params["p"];
                var directoryinfo = new DirectoryInfo(path);
                try
                {
                    directoryinfo.Delete(true);

                }
                catch (Exception)
                {
                }
                return "OK";
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Обновление категории
        /// </summary>
        /// <returns></returns>
        private static object RefreshCategory(HttpContext context)
        {
            try
            {
                var idx = int.Parse(context.Request.Params["idx"]);
                return AppSitesInfo.getCatProp(idx);
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Старт/Стоп сервиса
        /// </summary>
        /// <returns></returns>
        private static object StartStopService(HttpContext context, bool start)
        {
            try
            {
                WinService.StartStopService(context.Request.Params["srv"], context.Request.Params["links"].Split(','), start);
                return "OK";
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Старт/Стоп сервиса
        /// </summary>
        /// <returns></returns>
        private static object DeleteServices(HttpContext context)
        {
            try
            {
                var srv = context.Request.Params["srv"];
                string[] names = context.Request.Params["links"].Split(',');
                WinService.DeleteServices(srv, names, true);

                return "OK";
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Смена олицотворяющего юзера
        /// </summary>
        /// <returns></returns>
        private static object ChangeCertUser(HttpContext context)
        {
            try
            {
                string server = context.Request.Params["srv"];
                string sitename = context.Request.Params["sin"];
                string usrname = context.Request.Params["usr"];
                string password = context.Request.Params["pwd"];
                string[] certs64 = context.Request.Params["s64"].Split(',');

                ServerInfo.ChangeCertUser(server, sitename, usrname, password, certs64.ToList());

                return "OK";
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Включает/Выключает сертификат на IIS
        /// </summary>
        /// <returns></returns>
        private static object StateCertString(HttpContext context)
        {
            try
            {
                string server = context.Request.Params["srv"];
                string sitename = context.Request.Params["sin"];
                string[] certs64 = context.Request.Params["s64"].Split(',');

                ServerInfo.StateCertString(server, sitename, certs64.ToList());

                return "OK";
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Удаление сертификата из списка IIS
        /// </summary>
        /// <returns></returns>
        private static object RemoveCertString(HttpContext context)
        {
            try
            {
                string server = context.Request.Params["srv"];
                string sitename = context.Request.Params["sin"];
                string[] certs64 = context.Request.Params["s64"].Split(',');

                ServerInfo.RemoveCertString(server, sitename, certs64.ToList());

                return "OK";
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Удаление корневого сертификата
        /// </summary>
        /// <returns></returns>
        private static object RemoveRootCert(HttpContext context)
        {
            try
            {
                string server = context.Request.Params["srv"];
                string[] serials = context.Request.Params["sn"].Split(',');

                ServerInfo.RemoveRootCert(server, serials.ToList());

                return "OK";
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Сохраняет на сервер корневой сертификат пришедший в виде Base64 строки
        /// </summary>
        /// <returns></returns>
        private static object AddRootCertString(HttpContext context)
        {
            try
            {
                string server = context.Request.Params["srv"];
                string cert64 = context.Request.Params["c64"];

                return ServerInfo.AddRootCert(server, new List<string> { cert64 });
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Сохраняет на сервер сертификат пришедший в виде Base64 строки
        /// </summary>
        /// <returns></returns>
        private static object SaveCertString(HttpContext context)
        {
            try
            {
                string server = context.Request.Params["srv"];
                string cert64 = context.Request.Params["c64"];
                string sitename = context.Request.Params["sin"];
                string usrname = context.Request.Params["usr"];
                string password = context.Request.Params["pwd"];

                return ServerInfo.SaveCertString(server, sitename, usrname, password, new List<string> { cert64 });
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Информация о сервере
        /// </summary>
        /// <returns></returns>
        private static object GetServerInfo(HttpContext context)
        {
            try
            {
                var server = context.Request.Params["srv"];
                var sid = context.Request.Params["sid"];

                return (new ServerInfo(server, sid));
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Информация о сайтах/приложениях дял клиента
        /// </summary>
        /// <returns></returns>
        private static object GetProjects()
        {
            try
            {
                //return (new AppSitesInfo()).Categories;
                return (new AppSitesInfo());
            }
            catch (WarningException ex)
            {
                return ex;
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Информация о сайтах/приложениях для клиента
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static object DownLoad(HttpContext context)
        {
            AppSite app = JsonConvert.DeserializeObject(context.Request["json"], typeof(AppSite)) as AppSite;
            if (app != null)
            {
                app.DownLoadNewVersion();

                if (app.Mode != "edit" && app.Mode != "new" || app.Mode == null)
                {
                    app.AdjustByParams();
                    if (app.AppName != "Keysystems.BudgetNext" && app.CategoryName != "WinService")
                        app.SaveWebConfig();

                    var msg = app.Install();
                    return new AjaxResult { success = true, error = app.Errors + msg };
                }
                return app;
            }
            return null;
        }

        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Обновление виртуального ваталога
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static object Update(HttpContext context)
        {
            try
            {
                AppSite app = JsonConvert.DeserializeObject(context.Request["json"], typeof (AppSite)) as AppSite;
                if (app == null) return null;
                if (app.Mode == "new")
                {
                    app.DownLoadNewVersion();
                }

                app.AdjustByParams();
                app.SaveWebConfig();

                if (app.Mode != "edit")
                {

                    var msg = app.Mode != "copy" ? app.Install() : "";
                    msg += app.ExecScript();
                    return new AjaxResult { success = true, error = msg };
                }
                return new AjaxResult { success = true, error = app.Errors };
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Список доступных версий сайтов конкретной категории
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static object GetVersionsForCategory(HttpContext context)
        {
            try
            {
                return Category.AvailableUpdateVersions(context.Request["name"], context.Request["urlupd"]);
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Список доступных версий конкретного сайта
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static object GetVersionsForAppSite(HttpContext context)
        {
            try
            {
                AppSite app = JsonConvert.DeserializeObject(context.Request["json"], typeof(AppSite)) as AppSite;
                if (app == null) return null;
                return app.AvailableUpdateVersions();
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Сохранение параметров SSL для сайта
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static object SaveSSLParameters(HttpContext context)
        {
            try
            {
                AppSite app = JsonConvert.DeserializeObject(context.Request["json"], typeof(AppSite)) as AppSite;
                if (app == null) return null;

                app.SaveSSLFlags();
                return "OK";

            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }


        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Создание виртуального каталога
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static object Create(HttpContext context)
        {
            try
            {
                AppVersion appVersion = JsonConvert.DeserializeObject(context.Request["json"], typeof(AppVersion)) as AppVersion;
                AppSite app = new AppSite(appVersion);
                app.DownLoadNewVersion();
                return app;
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Удаление виртуальных каталогов
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static void Delete(HttpContext context)
        {
            try
            {
                Category.RemoveAppSites(context.Request["name"], context.Request["removePaths"]);
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Добавление закаченных сертификатов
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static AjaxResult CommitCerts(HttpContext context)
        {
            try
            {
                string server = context.Request.Params["srv"];
                string sitename = context.Request.Params["sin"];
                var p = context.Request["p"];
                string fileName = Path.Combine(Utils.RootFolder, @"TEMP\") + "tempcertsfile_sid_" + p;
                string strInfo = Utils.GetTextFromFile(fileName);
                var sn = JsonConvert.DeserializeObject(strInfo, typeof(List<string>)) as List<string>;
                ServerInfo.SaveCertString(server, sitename, "", "", sn);
                //File.Delete(fileName);
                return new AjaxResult { success = true };
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Добавление сертификатов из файлов
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        private static AjaxResult SaveFiles(HttpContext context)
        {
            try
            {
                var server = context.Request.Params["srv"];
                var sitename = context.Request.Params["sin"];
                var uploadFile = context.Request.Files["Filedata"];
                var stream = uploadFile.InputStream;
                byte[] myReadBuffer = new byte[uploadFile.ContentLength];
                stream.Read(myReadBuffer, 0, myReadBuffer.Length);

                var base64String = Encoding.UTF8.GetString(myReadBuffer);
                base64String = base64String.Replace("-----BEGIN CERTIFICATE-----", "");
                base64String = base64String.Replace("-----END CERTIFICATE-----", "");
                base64String = base64String.Replace("\n", "");
                base64String = base64String.Trim();

                try
                {
                    var binaryData =
                        Convert.FromBase64String(base64String);
                }
                catch (ArgumentNullException)
                {
                    return (new AjaxResult { success = false, error = "Файл пуст" });
                }
                catch (FormatException)
                {
                    return (new AjaxResult
                    {
                        success = false,
                        error = "Файл сохранен не в Base64 (DER)"
                    });
                }

                ServerInfo.SaveCertString(server, sitename, "", "", new List<string> {base64String});

                return new AjaxResult { success = true };
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }
        //--------------------------------------------------------------------------------------------------------
        /// <summary>
        /// Готовимся к обновлению себя самого
        /// </summary>
        /// <returns></returns>        
        private static AjaxResult BeginUpdateProcess()
        {
            try
            {
                var app = new AppSite(true);
                app.DownLoadNewVersion();
                app.AdjustByParams();
                app.SaveWebConfig();

                var msg = app.Install();

                return new AjaxResult { success = true, error  = app.Errors + msg};
            }
            catch (Exception ex)
            {
                throw ErrorManager.ErrorAJAX(ex);
            }
        }

        private static object GetProductVersion(HttpContext context)
        {
            var appFolder = context.Request.Params["app"];
            var apps = new AppSitesInfo();
            var app = apps.Categories[0].AppSites.FirstOrDefault(x => x.Path == "/" + appFolder);
            if (app == null) return null;
            return new { app.AppName, app.Version };
        }
    }

}

