﻿var _modalLayer, _info = {};
function IsEmpty(value, noTrim) {
    value = !noTrim ? trim(value) : value;
    return (value == null || value == 'null' || value == 'undefined' || value + "" == 'undefined' || value == "#empty#" || value == "\"#empty#\"" || value == 'NA' || value == '!NA!' || value == "" || value == "" || value == "NaN");
}
function IsEqual(value1, value2) {
    if (IsEmpty(value1) && IsEmpty(value2)) return true;
    return (value1 == value2 || trim((value1 + "").toLowerCase()) == trim((value2 + "").toLowerCase()));
}
function Replace(text, inchar, outchar) {
    if (IsEmpty(text)) return "";
    return (text + "").split(inchar).join(outchar);
}
function ltrim(xstr) {
    if (xstr == null) return xstr;
    xstr += "";
    if (!(xstr.indexOf(" ") == 0)) return xstr;
    var astr = xstr.split(" ");
    var i = 0;
    while (i < astr.length) {
        if (!(astr[i] == (""))) break;
        i++;
    }
    astr = astr.slice(i);
    return astr.join(" ");
}
function rtrim(xstr) {
    if (xstr == null) return xstr;
    xstr += "";
    if (!(xstr.lastIndexOf(" ") == xstr.length - 1)) return xstr;
    var astr = xstr.split(" ");
    var i = astr.length - 1;
    while (i > 0) {
        if (!(astr[i] == (""))) break;
        i--;
    }
    astr = astr.slice(0, i + 1);
    return astr.join(" ");
}
function trim(xstr) {
    return rtrim(ltrim(xstr));
}
function Copy(obj, level, clear) {
    if (level == 0) return null;
    if (!obj || typeof obj !== 'object') return obj;
    var c = (typeof obj.pop === 'function') ? [] : {};
    var p, v;
    for (p in obj)
        if (obj.hasOwnProperty(p))
        c[p] = (obj[p] && typeof obj[p] === 'object') ? Copy(obj[p], level == null ? level : (level - 1), clear) : (clear ? null : obj[p]);
    return c;
};
function ShowModalLayer(txt) {
    _modalLayer = Ext.MessageBox.show({
        msg: txt,
        width: 300,
        height: 200,
        closable: false
    });
}
function HideModalLayer() {
    if (!_modalLayer) return;
    _modalLayer.hide();
}
function ShowExtWindow_A(title, html, width, heigth, modal, items, buttons, id, buttonAlign, layout, sizeable) {
    if (IsEmpty(width))
        width = window.innerWidth * 0.8;
    if (IsEmpty(heigth))
        heigth = window.innerHeight * 0.8;
    buttonAlign = !buttonAlign ? 'right' : buttonAlign;
    html = !html ? "" : Replace(Replace(html, "#ERR#", "#err#"), "#MSG#", "msg");
    if (html != null && (html.indexOf("#err#") == 0 || html.indexOf("#msg#") == 0)) {
        html = "<table style='width:99%;height:99%;'><colgroup><col width='30'><col width='*'></colgroup>" +
            "<tr><td align=center valign=top><img src='images/" + (html.indexOf("#err#") == 0 ? "errorx32" : "info32") + ".png'/></td>" +
                "<td style='font-size:9pt' valign=top>" + html + "</td></tr></table>";
    }
    html = Replace(Replace(html, "#err#", ""), "#msg#", "");
    var win = new Ext.Window({ title: title,
        id: id,
        width: width,
        height: heigth,
        minWidth: 100,
        minHeight: 50,
        layout: IsEmpty(layout) ? "fit" : "form",
        plain: true,
        modal: modal,
        padding: 2,
        buttonAlign: buttonAlign,
        html: html,
        items: items,
        buttons: buttons,
        maximizable: !!sizeable,
        autoScroll: true
    });
    win.show();
}
function AjaxRequest(p) {
    var res = {};
    p.async = typeof p.async == "undefined" ? true : p.async;
    p.showError = typeof p.showError == "undefined" ? true : p.showError;
    p.params = typeof p.params == "undefined" ? { } : p.params;
    p.params.isAjax = 1;
    if (typeof p.modalLayerText != "undefined") ShowModalLayer(p.modalLayerText);
    if (typeof p.mlt != "undefined") ShowModalLayer(p.mlt);
    $.ajax({
        async: p.async,
        url: p.url,
        type: "POST",
        dataType: "text",
        timeout: 3600000,
        success: function(r) {
            try { HideModalLayer(); } catch (e) { }
            res = (r == "NO RESPONSE") ? r : Ext.util.JSON.decode(r);
            if (res.InnerException !== void 0)
                return ShowExtWindow_A("Ошибка", res.Message, 450, 300, true);
            if (!!p.success) p.success.apply(this, [res, p]);
        },
        error: function(r) {
            try { HideModalLayer(); } catch (e) { }
            if (!!p.error) p.error.apply(this, [r, p]);
            var ert = (typeof p.errorTitle != "undefined" ? (p.errorTitle + "\r\n") : "") + r.responseText;
            ert = ert.indexOf("#err#") > -1 ? ert : ("#err#" + ert);
            if (p.showError) ShowExtWindow_A("Ошибка", ert, 450, 300, true);
            res = { error: { msg: r.responseText} };
        },
        data: p.params
    });
    return res;
}
//----------------------------------------------------------------------------------------------------------------
//строковое представление даты, в IE даты вида 2013-11-11T00:00:00 не понимаются
function StrDateTimeX(v, sep) {
    if (IsEmpty(v)) return v;
    if (typeof v != "string") return v;
    if (v.indexOf("-") == -1) return v;
    var p = v.split("T");
    var pd = p[0].split("-");
    var h = 0, m = 0, s = 0;
    if (p.length > 1) {
        var pt = p[1].split(".")[0].split(":");
        h = pt[0] - 0;
        m = pt[1] - 0;
        s = pt[2] - 0;
    }
    sep = IsEmpty(sep) ? "/" : ".";
    return String.format("{0}{6}{1}{6}{2} {3}:{4}:{5}", pd[1], pd[2], pd[0], IntToStrByLen(h, 2), IntToStrByLen(m, 2), IntToStrByLen(s, 2), sep);
}
//-----------------------------------------------------------------------------------------------------
//Возращает строковое представление числа с дополненными символами 0 до длины len
function IntToStrByLen(str, len) {
    str += "";
    var shablon = "0000000000000000000000000000000000000000000000000000000000";
    if (IsEmpty(str)) return shablon.substring(0, len);
    if (!IsABSNumber(str)) return str;
    var det = len - ((str + "").length);
    if (det < 0) { return str; }
    return shablon.substring(0, det) + str;
}

//-----------------------------------------------------------------------------------------------------
//Это число или как? (положительное)
function IsABSNumber(str) {
    str += "";
    if (IsEmpty(str)) return false;
    if (str.indexOf("-") != -1) return false;
    var temp = str * 1 + "";
    return !(temp == "NaN" || temp == "Na");
}
//----------------------------------------------------------------------------------------------------------------
//строковое представление даты
function StrDateTime(v, withoutDay) {
    var wt, d, y;
    v = IsEmpty(v) ? "" : v;
    if (!v) return v;
    if (Ext.isNumber(v)) return v;

    v = StrDateTimeX(v);
    if (!wt) {
        if ((v + "").indexOf(".") != -1) return v.substring(withoutDay && v.split(".").length > 2 ? 3 : 0, 10);
        d = new Date(v);
        if (IsEmpty(d) || IsEmpty(Date.parse(v))) return (!v) ? null : v.substring(withoutDay ? 3 : 0, 10);
        y = d.getYear();
        y = (y < 1000) ? (1900 + y) : y; //костыль - в ie дата 4значная, в некоторых относительно 1900
        return withoutDay
            ? String.format("{0}.{1}", IntToStrByLen(d.getMonth() + 1, 2), y)
            : String.format("{0}.{1}.{2}", IntToStrByLen(d.getDate(), 2), IntToStrByLen(d.getMonth() + 1, 2), y);
    }
    d = new Date(v);
    if (!IsEmpty(d) && !IsEmpty(Date.parse(v))) {
        y = d.getYear();
        y = (y < 1000) ? (1900 + y) : y; //костыль - в ie дата 4значная, в некоторых относительно 1900
        var dd1 = d.getDate() - 0;
        var dd2 = Replace(v, "/", ".").split(".")[0] - 0;
        if (dd1 == dd2 || isNaN(dd2) || typeof dd2 == 'undefined') {
            return String.format("{0}.{1}.{2} {3}:{4}", IntToStrByLen(d.getDate(), 2), IntToStrByLen(d.getMonth() + 1, 2), y,
                IntToStrByLen(d.getHours(), 2), IntToStrByLen(d.getMinutes(), 2));
        }
        return String.format("{0}.{1}.{2} {3}:{4}", IntToStrByLen(d.getMonth() + 1, 2), IntToStrByLen(d.getDate(), 2), y,
                IntToStrByLen(d.getHours(), 2), IntToStrByLen(d.getMinutes(), 2));
    }
    v = Replace(v, "/", ".");
    v = Replace(v, "  ", " ");
    v = Replace(v, " ", ".");
    v = Replace(v, ":", ".");
    var dd = v.split(".")[0];
    var mm = v.split(".")[1];
    var yyyy = v.split(".")[2];
    var hh = v.length <= 10 ? 0 : v.split(".")[3];
    var mi = v.length <= 10 ? 0 : v.split(".")[4];
    return String.format("{0}.{1}.{2} {3}:{4}", IntToStrByLen(dd, 2), IntToStrByLen(mm), yyyy, IntToStrByLen(hh, 2), IntToStrByLen(mi, 2));
}
//строковое представление даты для БД
function StrDateTimeBD(v) {
    v = StrDateTime(v);
    if (!v) return v;
    return String.format("{0}{1}{2}", v.split(".")[2], v.split(".")[1], v.split(".")[0]);
}